
//% color="#ff9f06" iconWidth=50 iconHeight=40
namespace gravityasr {

    //% block="ASR begin mode [MODE] micMode [MICMODE]" blockType="command"
    //% MODE.shadow="dropdown" MODE.options="MODE" 
    //% MICMODE.shadow="dropdown" MICMODE.options="MICMODE" 
    export function begin(parameter: any, block: any) {
        let mode = parameter.MODE.code;
        let micmode = parameter.MICMODE.code;
        Generator.addImport("from dfrobot_asr import DFRobot_ASR");
        Generator.addInit(`asrobject`,`gravity_asr = DFRobot_ASR()`);
        Generator.addCode(`gravity_asr.begin(gravity_asr.${mode}, gravity_asr.${micmode})`);
 
    }
    
    //% externalFunc
    export function validateStr_(str) {
        let regx: RegExp =  /^[a-zA-Z\s]+$/;  
        if (!regx.test(str)) {
            return null;
        }
        return str;
    }

    //% block="ASR add command [COMMAND] number [NUMBER]" blockType="command"
    //% COMMAND.shadow="string" COMMAND.defl="kai deng"  COMMAND.params.validateFunc="validateStr_"
    //% NUMBER.shadow="number" NUMBER.defl="1" 
    export function addCommand(parameter: any, block: any) {
        let command = parameter.COMMAND.code;
        let num = parameter.NUMBER.code;
        Generator.addCode(`gravity_asr.add_command(${command},${num});`);
 
    }
    //% block="ASR start" blockType="command"
    export function start() {
        Generator.addCode("gravity_asr.start()");
 
    }
       //% block="ASR read" blockType="reporter"
       export function read() {

        
        Generator.addCode(["gravity_asr.read()",Generator.ORDER_UNARY_POSTFIX]);
 
    } 

}
